#ifndef PMSM_STATE
#define PMSM_STATE

#include <stdint.h>
#include <semaphore.h>

#define OLD_POS_NUM 	50
#define MAX_DUTY	170
#define MAX_SPEED 	(7*OLD_POS_NUM)

struct rpi_in;

struct rpi_state{
	struct rpi_in* spi_dat;		/* spi data */
	sem_t thd_par_sem;		/* data metual exlusion access */
	uint8_t test;			/* configuratin byte - pwm enabl. bits etc. */
	uint32_t tf_count;		/* number of transfer*/

	uint16_t index_dist;		/* distance to index position */
	unsigned char index_ok;		/* we have actual index position */

	uint16_t pwm1, pwm2, pwm3;	/* pwm duty cycles*/
	uint16_t t_pwm1, t_pwm2, t_pwm3;/* debug*/

	int duty;			/* duty cycle of pwm */
	int desired_pos;		/* desired position */
	int old_pos[OLD_POS_NUM];	/* old  positions */
	int desired_spd;		/* desired speed */
	int speed;

	char commutate;			/* zapina prepocet duty na jednotlive pwm */
	char pos_reg_ena;		/* position regulation enable */
	char spd_reg_ena;		/* speed rugulation enable */
};

#endif /*PMSM_STATE*/
